#include <stdint.h>
#include <stdio.h>

#include "devices.h"
#include "instruments.h"
#include "drv_instrument.h"
#include "drv_dac.h"

#define DAC_CHAN_X 0
#define DAC_CHAN_Y 1

dac_t *dac;
instrument_t *ctlpanel;

void init() {
    dac = dac_open(DAC_1);
    ctlpanel = instrument_open(CTLPANEL);
}

void main() {
    init();
    uint32_t xv,yv,lastx,lasty;
    boolean upd;
    lastx = 0;
    lasty = 0;
    for (;;) {
        upd = false;
        xv = instrument_get_value(ctlpanel,CTLPANEL_XIN);
        if (xv!=lastx) {
            upd = true;
            lastx = xv;
        }
        yv = instrument_get_value(ctlpanel,CTLPANEL_YIN);
        if (yv!=lasty) {
            upd = true;
            lasty = yv;
        }
        if (upd) {
           printf("X=%d Y=%d\n",xv,yv);
           instrument_set_value(ctlpanel,CTLPANEL_XOUT,xv);
           dac_write(dac,DAC_CHAN_X,xv,false);
           instrument_set_value(ctlpanel,CTLPANEL_YOUT,yv);
           dac_write(dac,DAC_CHAN_Y,yv,true);
           upd = false;
        }
    }
}

